#include <stdio.h> /* RTK 2008.3.1 */
#include <stdbool.h>

#define MaxN 6
#define MaxM 1000000

int n, b, m, mm;
bool zeVidel[MaxM];

int Nasl(int pin)
{
	int i, vsota = 0, novi = (pin % mm) * b;
	for (i = 0; i < n; i++) { vsota += pin % b; pin /= b; }
	return novi + vsota % b;
}

int main(int argc, char **argv)
{
	int z, u, v, d, dolzinaZ, stKrajsih, stCiklov;

	/* Preberimo vhodne podatke. */
	FILE *f = fopen(argc > 1 ? argv[1] : "pini.in", "rt");
	fscanf(f, "%d", &n); b = 10;
	m = 1; for (u = 0; u < n; u++) m *= b; /* m = 10^n */
	mm = m / b; /* mm = 10^(n - 1) */
	fscanf(f, "%d", &z); fclose(f);

	for (u = 0; u < m; u++) zeVidel[u] = false;
	/* Poglejmo, po koliko korakih se zane ponavljati PIN z. */
	for (v = z, d = 0; ! zeVidel[v]; v = Nasl(v), d++) zeVidel[v] = true;
	dolzinaZ = d; stCiklov = 1; stKrajsih = 0;
	/* Preglejmo zdaj e ostale PINe. */
	for (u = 0; u < m; u++) if (! zeVidel[u])
	{
		/* Raunajmo naslednike u-ja, dokler ne pridemo spet do u. */
		for (v = u, d = 0; ! zeVidel[v]; v = Nasl(v), d++) zeVidel[v] = true;
		/* Na tem ciklu je d PINov, ki se zanejo ponavljati po d korakih.
		   Je to manj kot pri PINu z, ki se zane ponavljati po DolzinaZ korakih? */
		stCiklov++;
		if (d < dolzinaZ) stKrajsih += d;
	}

	/* Izpiimo rezultate. */
	f = fopen(argc > 2 ? argv[2] : "pini.out", "wt");
	fprintf(f, "%d\n%d\n%d\n", dolzinaZ, stKrajsih, stCiklov);
	fclose(f); return 0;
}
