# -*- coding: Windows-1250 -*-

def Naslednji(pin, n, b):
    novi = pin % (b ** (n - 1))
    vsota = 0
    while pin > 0: vsota += pin % b; pin //= b
    return novi * b + (vsota % b)

# Raazliica, ki porabi manj pomnilnika.
def PrestejCikle(pin, n, b):
    # Najprej poglejmo, na kako dolgem ciklu je zacetni PIN.
    dolzina = 1; u = Naslednji(pin, n, b)
    while u != pin: u = Naslednji(u, n, b); dolzina += 1
    # Preglejmo zdaj sistematino vse cikle.
    stPinovPoDolzini = {}
    for pin in xrange(b ** n):
        u = Naslednji(pin, n, b); d = 1
        while u > pin: u = Naslednji(u, n, b); d += 1
        if u < pin: continue # Ta cikel smo neko prej e pregledali.
        stPinovPoDolzini[d] = stPinovPoDolzini.get(d, 0) + d
    return dolzina, stPinovPoDolzini

# Evklidov algoritem za najveji skupni delitelj.
def gcd(u, v):
    while v > 0: (u, v) = (v, u % v)
    return u
# Najmanji skupni vekratnik.
def lcm(u, v): return (u // gcd(u, v)) * v

# Preberimo vhodne podatke.
from sys import argv
f = file((len(argv) > 1) and argv[1] or "pini.in", "rt")
n = int(f.readline())
pin = f.readline().strip()
f.close()
# Izraunajmo zaetne tevke pripadajoega dvojikega in petikega zaporedja.
pin2 = sum((int(pin[i]) % 2) * (2 ** (n - 1 - i)) for i in xrange(n))
pin5 = sum((int(pin[i]) % 5) * (5 ** (n - 1 - i)) for i in xrange(n))
# Pretejmo, koliko ciklov kakne doline je pri dvojikih in petikih zaporedjih.
dolzina2, st2 = PrestejCikle(pin2, n, 2)
dolzina5, st5 = PrestejCikle(pin5, n, 5)
# Kako dolg je cikel naega zaetnega (desetikega) PINa?
dolzina = lcm(dolzina2, dolzina5)
# Izraunajmo zdaj, koliko je ciklov pri desetikih PINih
# in koliko PINov je na krajih ciklih od naega zaetnega.
stNaKrajsih = 0; stCiklov = 0
for (d2, koliko2) in st2.iteritems():
    for (d5, koliko5) in st5.iteritems():
        d = lcm(d2, d5)
        koliko = koliko2 * koliko5 
        # Imamo 'koliko' razlinih desetikih PINov, ki se zanejo ponavljati po 'd' korakih.
        # Torej na vsakih 'd' takih pinov pride en cikel.
        stCiklov += koliko // d
        if d < dolzina: stNaKrajsih += koliko
# Izpiimo rezultate.
f = file(len(argv) > 2 and argv[2] or "pini.out", "wt")
f.write("%d\n%d\n%d\n" % (dolzina, stNaKrajsih, stCiklov))
f.close()
